SuperStrict
Framework brl.standardio
Import brl.blitz
Import brl.filesystem
Import brl.stream
Import brl.retro



Global path$="code.txt"
If AppArgs.length>1 Then
	Local ona%=0
	For Local a$=EachIn AppArgs
		ona:+1
		If ona=2 Then path=a
	Next
EndIf



Global code@[1]

Local fil:TStream=ReadFile(path)
If Not fil Print "Could not load "+path;Input;End

Global size:Long=0

Local index:Long=0
Global cmds$="+<?,."
Repeat
	Local lin$=ReadLine(fil)
	For Local s%=1 To Len(lin)
		If Instr(cmds,Mid(lin,s,1))
			size:+1
			code=code[..size]
			code[size-1]=Asc(Mid(lin,s,1))
		EndIf
	Next
Until Eof(fil)
CloseFile fil






Global dat@[1],dsize:Long=0
Function push(val%)
	dsize:+1
	dat=dat[..dsize]
	dat[dsize-1]=val
End Function
Function pop%(pos%)
	Local ret%=dat[pos]
	For Local shift%=pos To dsize-2
		dat[shift]=dat[shift+1]
	Next
	dsize:-1
	Return ret
End Function



Print "Executing "+path
Print ""


Global pos%=0,mem%=36
Repeat
	If pos=>size Exit
		Select Chr(code[pos])
			Case "@" push(Not pop(dsize-1))
			Case "<" push 0
			Case ">" pop dsize-1
			Case "." WriteStdout dat[dsize-1]
			Case "[" If dat[dsize-1]<=0 Then pos=match(pos,"[","]",1)
			Case "]" pos=match(pos,"]","[",-1)-1
		End Select
	pos:+1
Forever



Print ""
Print ""
Print "Execution complete."
Input
End




Function match:Long(start:Long,inc$,dec$,dir%)
	Local nest:Long=1,in:Long=start+dir
	Repeat
		If in=>size Or in<0 
			Print "ERROR: could not find matching "+dec;Input;End
		EndIf
		If Chr(code[in])=inc nest:+1
		If Chr(code[in])=dec nest:-1
		If nest=0 Return in
		in:+dir
	Forever
End Function





